//+------------------------------------------------------------------+
//|                                               Pyramid_Kharko.mq4 |
//|                               Copyright  2006,   |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006,   "


extern int    Magic_      = 1;     //   ,    
extern int    Trend        = 0;     // 0 -  , 1 -  
extern double Lots         = 0.1;   //  
extern int    Step         = 0;     //   (   , pt)
extern int    MinProfit    = 40;   //    

int         Lok;
int         CurProfit;
datetime    prevtime1;
double      minlot, maxlot;
double      buys, sells;
double      max_b, min_b, max_s, min_s;
int         max_bt, min_bt, max_st, min_st;

//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForOpen()
{
//---- 
   
   int    ticket;
   double MyLot;
   
   MyLot=Lots;
   CurProfit=0; 
   max_b=0;    min_b=0;    max_s=0;    min_s=0;
   max_bt=0;   min_bt=0;   max_st=0;   min_st=0;
   buys=0;     sells=0;

   minlot=MarketInfo(Symbol(),MODE_MINLOT);
   int spred = MarketInfo(Symbol(),MODE_SPREAD);
   
//   if(Step<spred) Step=spred;
   if(Step==0) Step=spred;
   
   for(int i=0;i<OrdersTotal();i++)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()!=Symbol() || OrderMagicNumber()!=Magic_) continue;

      if(OrderType()==OP_BUY)  
      {
         buys+=OrderLots();
         if(max_b<OrderOpenPrice())             {max_b=OrderOpenPrice(); max_bt=OrderTicket();}
         if(min_b>OrderOpenPrice() || min_b==0) {min_b=OrderOpenPrice(); min_bt=OrderTicket();}
         
         CurProfit+=(OrderLots()/minlot)*(Bid-OrderOpenPrice())/Point;
      }
      if(OrderType()==OP_SELL) 
      {
         sells+=OrderLots();
         if(max_s<OrderOpenPrice())             {max_s=OrderOpenPrice(); max_st=OrderTicket();}
         if(min_s>OrderOpenPrice() || min_s==0) {min_s=OrderOpenPrice(); min_st=OrderTicket();}

         CurProfit+=(OrderLots()/minlot)*(OrderOpenPrice()-Ask)/Point;
      }
   }
   
   if(buys<=sells) CurProfit=CurProfit+spred*buys/minlot;
   else CurProfit=CurProfit+spred*sells/minlot;
   
   if(maxlot<buys+sells) {maxlot=buys+sells; Print("maxlot = ", maxlot);}
//--
   if(CurProfit-Lok>=MinProfit) {Print("CurProfit = ", CurProfit);ForClose();return(0);}

//   if(CurProfit-Lok>=0 && buys!=0 && sells!=0)
   if(CurProfit>=0 && buys!=0 && sells!=0)
   {
      if(Ask>=max_b) CheckForClose(min_bt,min_st);
      if(Bid<=min_s) CheckForClose(max_bt,max_st);
      Print("CurProfit = ", CurProfit, "LOK = ", Lok);
   }
   if(CurProfit>=0.8*MinProfit) Print("CurProfit = ", CurProfit, "LOK = ", Lok);

//--
   if(buys==0 && sells==0)
   {
      if(Trend==0)
      {
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,1,0,0,"",Magic_,0,CLR_NONE);
         if(ticket<=0)     {Print("Error opening BUY order : ",GetLastError()); return(0);}
      }
      else
      {
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,1,0,0,"",Magic_,0,CLR_NONE);
         if(ticket<=0)     {Print("Error opening SELL order : ",GetLastError()); return(0);}
      }
      return(0);
   }
//--
   if(buys!=0) 
   {
      if(Ask-max_b>=Step*Point)
      {
         ticket=OrderSend(Symbol(),OP_BUY,MyLot,Ask,1,0,0,"",Magic_,0,CLR_NONE);
         if(ticket<=0)     Print("Error opening BUY order : ",GetLastError()); 
         while(GetLastError()>=129 && GetLastError()<=148) OrderSend(Symbol(),OP_BUY,MyLot,Ask,1,0,0,"",Magic_,0,CLR_NONE);
         return(0);
      }

      if(min_b-Ask>=Step*Point && sells==0)
      {
         ticket=OrderSend(Symbol(),OP_SELL,MyLot,Bid,1,0,0,"",Magic_,0,CLR_NONE);
         if(ticket<=0)     Print("Error opening SELL order : ",GetLastError()); 
         while(GetLastError()>=129 && GetLastError()<=148) OrderSend(Symbol(),OP_SELL,MyLot,Bid,1,0,0,"",Magic_,0,CLR_NONE);
         return(0);
      }
   }

//--
   if(sells!=0) 
   {
      if(min_s-Bid>=Step*Point)
      {
         ticket=OrderSend(Symbol(),OP_SELL,MyLot,Bid,1,0,0,"",Magic_,0,CLR_NONE);
         if(ticket<=0)     Print("Error opening SELL order : ",GetLastError()); 
         while(GetLastError()>=129 && GetLastError()<=148) OrderSend(Symbol(),OP_SELL,MyLot,Bid,1,0,0,"",Magic_,0,CLR_NONE);
         return(0);
      }

      if(Bid-max_s>=Step*Point && buys==0)
      {
         ticket=OrderSend(Symbol(),OP_BUY,MyLot,Ask,1,0,0,"",Magic_,0,CLR_NONE);
         if(ticket<=0)     Print("Error opening BUY order : ",GetLastError()); 
         while(GetLastError()>=129 && GetLastError()<=148)OrderSend(Symbol(),OP_BUY,MyLot,Ask,1,0,0,"",Magic_,0,CLR_NONE);
         return(0);
      }
   }
//----
}
//+------------------------------------------------------------------+
void CheckForClose(int TB, int TS)
{
   double MinLots, Price;
   
   if(OrderSelect(TB,SELECT_BY_TICKET,MODE_TRADES)==false) return(0);
   MinLots=OrderLots();
   Price=OrderOpenPrice();

   if(OrderSelect(TS,SELECT_BY_TICKET,MODE_TRADES)==false) return(0);
   MinLots=MathMin(MinLots,OrderLots());
   int LokProfit=(MinLots/minlot)*(Price-OrderOpenPrice())/Point;

   if(CurProfit-Lok-LokProfit>0) {OrderCloseBy(TB,TS); Lok=Lok+LokProfit;}
   
//----
}
//+------------------------------------------------------------------+
void ForClose()
{
   while(buys!=0 && sells!=0)
   {
      if(buys>=sells)CheckForClose(min_bt,min_st);
      if(buys<sells) CheckForClose(max_bt,max_st);
      
      max_b=0;    min_b=0;    max_s=0;    min_s=0;
      max_bt=0;   min_bt=0;   max_st=0;   min_st=0;
      buys=0;     sells=0;

      for(int i=0;i<OrdersTotal();i++)
      {
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()!=Symbol() || OrderMagicNumber()!=Magic_) continue;

         if(OrderType()==OP_BUY)  
         {
            buys+=OrderLots();
            if(max_b<OrderOpenPrice())             {max_b=OrderOpenPrice(); max_bt=OrderTicket();}
            if(min_b>OrderOpenPrice() || min_b==0) {min_b=OrderOpenPrice(); min_bt=OrderTicket();}
         }
         if(OrderType()==OP_SELL) 
         {
            sells+=OrderLots();
            if(max_s<OrderOpenPrice())             {max_s=OrderOpenPrice(); max_st=OrderTicket();}
            if(min_s>OrderOpenPrice() || min_s==0) {min_s=OrderOpenPrice(); min_st=OrderTicket();}
         }
      }
   }
   if(buys==0 || sells==0)
   {
      for(i=0;i<OrdersTotal();i++)
      {
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()!=Symbol() || OrderMagicNumber()!=Magic_) continue;

         if(OrderType()==OP_BUY)  {OrderClose(OrderTicket(),OrderLots(),Bid,3,CLR_NONE);Trend=0;}
         if(OrderType()==OP_SELL) {OrderClose(OrderTicket(),OrderLots(),Ask,3,CLR_NONE);Trend=1;}
      }
   }
   Lok=0;
//--
}
//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()
  {
   if(prevtime1==CurTime()+1) return(0);
   prevtime1=CurTime()+1;
   
   CheckForOpen();
//----
  }
//+------------------------------------------------------------------+